Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2242026

Summary: Review Request: python-pyuca - Python implementation of the Unicode Collation Algorithm
Product: [Fedora] Fedora Reporter: Sandro <gui1ty>
Component: Package ReviewAssignee: Benson Muite <benson_muite>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: benson_muite, code, package-review, rfontana
Target Milestone: ---Flags: benson_muite: fedora-review+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2024-03-23 13:18:26 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941, 2106899    

Description Sandro 2023-10-03 23:15:09 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/gui1ty/spyder/fedora-rawhide-x86_64/06488008-python-pyuca/python-pyuca.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/gui1ty/spyder/fedora-rawhide-x86_64/06488008-python-pyuca/python-pyuca-1.2-1.fc40.src.rpm

Description: 
Python implementation of the Unicode Collation Algorithm (UCA). It
passes 100% of the UCA conformance tests for Unicode 5.2.0 (Python
2.7), Unicode 6.3.0 (Python 3.3+), Unicode 8.0.0 (Python 3.5+), Unicode
9.0.0 (Python 3.6+), and Unicode 10.0.0 (Python 3.7+) with a
variable-weighting setting of Non-ignorable.

Fedora Account System Username: gui1ty

Copr build: https://copr.fedorainfracloud.org/coprs/gui1ty/spyder/build/6488008/

Comment 1 Sandro 2023-10-03 23:32:23 UTC
This is a new dependency for Spyder in the upcoming 6.x release. I'm currently looking into updating rawhide to the latest pre-release, 6.0.0a2 (RPM: 6.0.0~a2).

The Copr build includes a fedora-review analysis.

Comment 2 Benson Muite 2023-10-04 06:15:01 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Dist tag is present.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "MIT License", "*No copyright* MIT
     License". 37 files have unknown license. Detailed output of
     licensecheck in /home/FedoraPackaging/reviews/python-pyuca/2242026-
     python-pyuca/licensecheck.txt
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Macros in Summary, %description expandable at SRPM build time.
     Note: Macros in: python3-pyuca (description)
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 11348 bytes in 1 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[-]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Spec use %global instead of %define unless justified.
     Note: %define requiring justification: %define autorelease(e:s:pb:n)
     %{?-p:0.}%{lua:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-pyuca-1.2-1.fc38.noarch.rpm
          python-pyuca-1.2-1.fc38.src.rpm
================================================== rpmlint session starts =================================================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpzlgu28n6')]
checks: 31, packages: 2

=================== 2 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 6.6 s ==================




Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 1

 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.4 s 



Source checksums
----------------
https://github.com/jtauber/pyuca/archive/v1.2/pyuca-1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 41a47aa598c152a52b1dc4aa210c6db62cc7f72d13cee2caee80841c3cc49e19
  CHECKSUM(SHA256) upstream package : 41a47aa598c152a52b1dc4aa210c6db62cc7f72d13cee2caee80841c3cc49e19


Requires
--------
python3-pyuca (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python3-pyuca:
    python-pyuca
    python3-pyuca
    python3.11-pyuca
    python3.11dist(pyuca)
    python3dist(pyuca)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2242026 -m fedora-38-x86_64
Buildroot used: fedora-38-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Haskell, R, Perl, Ruby, SugarActivity, Ocaml, fonts, PHP, Java, C/C++
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH


Comments:
a) Koji build:
https://koji.fedoraproject.org/koji/taskinfo?taskID=107042796
b) license text at:
https://github.com/jtauber/pyuca/blob/master/LICENSE-allkeys
differs a little from ICU license text:
https://spdx.org/licenses/ICU.html
Would be helpful for legal to check this.

Comment 3 Sandro 2023-10-04 09:12:27 UTC
Thanks for the review. I agree, a license review for the ICU license is needed. SPDX Diff gave me a ~70% match.

Should I sent a mail to fedora-legal mailinglist or will this be picked up automatically since it blocks the tracker bug?

Comment 4 Sandro 2023-10-04 12:52:38 UTC
I had a look at pyuca/allkeys*.txt. They all contain a link in the header to the Unicode Terms of Use (http://www.unicode.org/terms_of_use.html), which redirects to https://www.unicode.org/copyright.html. In there, they refer to Unicode Data Files and Software License: https://www.unicode.org/license.txt

However none of the Unicode-* licenses is a perfect match and even when I diff the license.txt, the SPDX License Diff plugin I use in my browser, still suggests ICU is the closest match. I'm afraid the license needs to be added akin to Unicode-DFS-2016 (https://spdx.org/licenses/Unicode-DFS-2016.html) if it's permissible at all.

:sigh:

Comment 5 Benson Muite 2023-10-04 14:55:43 UTC
File an issue at https://gitlab.com/fedora/legal/fedora-license-data/-/issues

Comment 6 Richard Fontana 2023-10-04 19:17:31 UTC
Yes, please file a Fedora License Data issue. What are likely similar Unicode issues have come up in review of other packages and in some cases we have concluded that the license is inoperative or is not really the Unicode ToU.

Comment 7 Richard Fontana 2023-10-04 19:17:53 UTC
Yes, please file a Fedora License Data issue. What are likely similar Unicode issues have come up in review of other packages and in some cases we have concluded that the license is inoperative or is not really the Unicode ToU.

Comment 8 Sandro 2023-10-04 22:40:11 UTC
(In reply to Richard Fontana from comment #7)
> Yes, please file a Fedora License Data issue. What are likely similar
> Unicode issues have come up in review of other packages and in some cases we
> have concluded that the license is inoperative or is not really the Unicode
> ToU.

It seems the license referred to (in the files themselves) has already been submitted for review by Miroslav Suchý as Unicode License v3 (https://gitlab.com/fedora/legal/fedora-license-data/-/issues/314). It's currently pending OSI approval and SPDX identifier assignment.

However the license text in `LICENSE-alltext` (https://raw.githubusercontent.com/jtauber/pyuca/v1.2/LICENSE-allkeys) does not match the license text submitted by Miroslav (https://github.com/spdx/license-list-XML/issues/2105#issuecomment-1701165975). It's missing the first and the fourth paragraph. So, if Unicode License v3 makes it into SPDX, what needs to be done about `LICENSE-alltext`?

Or, since the situation for `pyuca` is a bit murky, should I submit a separate license review request, anyway?

Comment 9 Sandro 2023-10-04 22:53:17 UTC
(In reply to Sandro from comment #8)
> However the license text in `LICENSE-alltext`
> (https://raw.githubusercontent.com/jtauber/pyuca/v1.2/LICENSE-allkeys) does
> not match the license text submitted by Miroslav
> (https://github.com/spdx/license-list-XML/issues/2105#issuecomment-
> 1701165975). It's missing the first and the fourth paragraph. So, if Unicode
> License v3 makes it into SPDX, what needs to be done about `LICENSE-alltext`?

s/LICENSE-alltext/LICENSE-allkeys/g

I'm getting confused already...

Comment 10 Benson Muite 2023-10-05 05:35:24 UTC
The latest version of the data files seems to be under v3 license:
https://www.unicode.org/Public/UCA/latest/allkeys.txt
May need to check for license text associated with each allkeys.txt
release from Unicode consortium and/or Internet Archive Wayback Machine.
The license text does not have an "or later" clause.

Comment 11 Sandro 2023-10-14 10:23:25 UTC
Formal license review submitted. Seeing all the different `allkeys*.txt` files with different dates, referring to different versions of the Unicode license, this will be fun. ;-)

Comment 12 Sandro 2024-03-08 13:07:14 UTC
Based on the feedback from legal I've submitted https://github.com/jtauber/pyuca/pull/28 and am currently waiting on upstream to respond. Based on the feedback in https://github.com/jtauber/pyuca/issues/27 I'm rather confident this will be merged in due time.

Is it an option to proceed with this review applying the PR as a patch? It seems pretty clear that all the Unicode character encodings are governed by the Unicode-3.0 license with legal even suggesting that "mere character encodings ought not be seen as requiring a license".[1]

[1] https://gitlab.com/fedora/legal/fedora-license-data/-/issues/379#note_1798472528

Comment 13 Sandro 2024-03-15 10:24:23 UTC
Ping?

The proposed update to the spec file and the resulting SRPM:

Spec URL: https://gui1ty.fedorapeople.org/review/python-pyuca.spec
SRPM URL: https://gui1ty.fedorapeople.org/review/python-pyuca-1.2-2.fc41.src.rpm

Comment 14 Fedora Review Service 2024-03-15 17:57:33 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7165359
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2242026-python-pyuca/fedora-rawhide-x86_64/07165359-python-pyuca/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 15 Sandro 2024-03-23 10:05:59 UTC
This is no longer blocking Legal. I'd like to proceed. This is the last hurdle for releasing Spyder 6.0.0a4.

Comment 16 Benson Muite 2024-03-23 11:33:17 UTC
Thanks for following up on the license.

Comment 17 Sandro 2024-03-23 13:00:25 UTC
Thanks for the review!

Comment 18 Fedora Admin user for bugzilla script actions 2024-03-23 13:01:22 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/python-pyuca

Comment 19 Fedora Update System 2024-03-23 13:15:02 UTC
FEDORA-2024-b3b28f8702 (python-pyuca-1.2-1.fc41) has been submitted as an update to Fedora 41.
https://bodhi.fedoraproject.org/updates/FEDORA-2024-b3b28f8702

Comment 20 Fedora Update System 2024-03-23 13:18:26 UTC
FEDORA-2024-b3b28f8702 (python-pyuca-1.2-1.fc41) has been pushed to the Fedora 41 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 21 Fedora Update System 2024-03-26 17:17:32 UTC
FEDORA-2024-c552c1b9fd (python-cmap-0.2.0-1.fc40, python-pyconify-0.1.6-1.fc40, and 5 more) has been submitted as an update to Fedora 40.
https://bodhi.fedoraproject.org/updates/FEDORA-2024-c552c1b9fd

Comment 22 Fedora Update System 2024-03-27 02:35:30 UTC
FEDORA-2024-c552c1b9fd has been pushed to the Fedora 40 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2024-c552c1b9fd \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2024-c552c1b9fd

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 23 Fedora Update System 2024-03-30 01:56:16 UTC
FEDORA-2024-c552c1b9fd (python-cmap-0.2.0-1.fc40, python-pyconify-0.1.6-1.fc40, and 5 more) has been pushed to the Fedora 40 stable repository.
If problem still persists, please make note of it in this bug report.